OGRE-Next: Ogre::NULLRenderSystem Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::NULLRenderSystem Class Referencefinal

Implementation of NULL as a rendering system. More...

`#include <OgreNULLRenderSystem.h>`

Inheritance diagram for Ogre::NULLRenderSystem:
[legend]

## Public Member Functions
| NULLRenderSystem ()
| ~NULLRenderSystem () override
void | _beginFrame () override
| Signifies the beginning of a frame, i.e.
void | _convertProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest) override
| Converts a uniform projection matrix to suitable for this render system.
Window * | _createRenderWindow (const String &name, uint32 width, uint32 height, bool fullScreen, const NameValuePairList *miscParams=0) override
| Creates a new rendering window.
void | _dispatch (const HlmsComputePso &pso) override
void | _endFrame () override
| Ends rendering of a frame to the current viewport.
Window * | _initialise (bool autoCreateWindow, const String &windowTitle="OGRE Render Window") override
| Start up the renderer using the settings selected (Or the defaults if none have been selected).
void | _render (const CbDrawCallIndexed *cmd) override
| Renders the VAO. Assumes _setVertexArrayObject has already been called.
void | _render (const CbDrawCallStrip *cmd) override
void | _render (const v1::CbDrawCallIndexed *cmd) override
| Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called.
void | _render (const v1::CbDrawCallStrip *cmd) override
void | _renderEmulated (const CbDrawCallIndexed *cmd) override
void | _renderEmulated (const CbDrawCallStrip *cmd) override
void | _setComputePso (const HlmsComputePso *pso) override
| Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level).
void | _setCurrentDeviceFromTexture (TextureGpu *texture) override
| Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture.
void | _setHlmsSamplerblock (uint8 texUnit, const HlmsSamplerblock *Samplerblock) override
| See HlmsSamplerblock.
void | _setIndirectBuffer (IndirectBufferPacked *indirectBuffer) override
void | _setPipelineStateObject (const HlmsPso *pso) override
void | _setPointParameters (Real size, bool attenuationEnabled, Real constant, Real linear, Real quadratic, Real minSize, Real maxSize) override
| Sets the size of points and how they are attenuated with distance.
void | _setPointSpritesEnabled (bool enabled) override
| Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.
void | _setProjectionMatrix (const Matrix4 &m) override
| Sets the projection transform matrix.
void | _setRenderOperation (const v1::CbRenderOp *cmd) override
void | _setSamplers (uint32 slotStart, const DescriptorSetSampler *set) override
void | _setSamplersCS (uint32 slotStart, const DescriptorSetSampler *set) override
void | _setSurfaceParams (const ColourValue &ambient, const ColourValue &diffuse, const ColourValue &specular, const ColourValue &emissive, Real shininess, TrackVertexColourType tracking=TVC_NONE) override
| Sets the surface properties to be used for future rendering.
void | _setTexture (size_t unit, TextureGpu *texPtr, bool bDepthReadOnly) override
| Sets the texture to bind to a given texture unit.
void | _setTextureBlendMode (size_t unit, const LayerBlendModeEx &bm) override
| Sets the texture blend modes from a TextureUnitState record.
void | _setTextureCoordCalculation (size_t unit, TexCoordCalcMethod m, const Frustum *frustum=0) override
| Sets a method for automatically calculating texture coordinates for a stage.
void | _setTextureMatrix (size_t unit, const Matrix4 &xform) override
| Sets the texture coordinate transformation matrix for a texture unit.
void | _setTextures (uint32 slotStart, const DescriptorSetTexture *set, uint32 hazardousTexIdx) override
void | _setTextures (uint32 slotStart, const DescriptorSetTexture2 *set) override
void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture *set) override
void | _setTexturesCS (uint32 slotStart, const DescriptorSetTexture2 *set) override
void | _setUavCS (uint32 slotStart, const DescriptorSetUav *set) override
void | _setVertexArrayObject (const VertexArrayObject *vao) override
| Part of the low level rendering interface.
void | _setViewMatrix (const Matrix4 &m) override
| Sets the view transform matrix.
void | _setWorldMatrix (const Matrix4 &m) override
| Sets the world transform matrix.
void | _useLights (const LightList &lights, unsigned short limit) override
| Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).
void | beginGPUSampleProfile (const String &name, uint32 *hashCache) override
void | beginProfileEvent (const String &eventName) override
| This marks the beginning of an event for GPU profiling.
void | bindGpuProgramParameters (GpuProgramType gptype, GpuProgramParametersSharedPtr params, uint16 variabilityMask) override
| Bind Gpu program parameters.
void | bindGpuProgramPassIterationParameters (GpuProgramType gptype) override
| Only binds Gpu program parameters used for passes that have more than one iteration rendering.
void | clearFrameBuffer (RenderPassDescriptor *renderPassDesc, TextureGpu *anyTarget, uint8 mipLevel) override
| Immediately clears the whole frame buffer on the selected RenderPassDescriptor.
HardwareOcclusionQuery * | createHardwareOcclusionQuery () override
| Create an object for performing hardware occlusion queries.
RenderPassDescriptor * | createRenderPassDescriptor () override
RenderSystemCapabilities * | createRenderSystemCapabilities () const override
| Query the real capabilities of the GPU and driver in the RenderSystem.
void | deinitGPUProfiling () override
void | endGPUSampleProfile (const String &name) override
void | endProfileEvent () override
| Ends the currently active GPU profiling event.
void | flushCommands () override
VertexElementType | getColourVertexElementType () const override
| Get the native VertexElementType for a compact 32-bit colour value for this rendersystem.
ConfigOptionMap & | getConfigOptions () override
| Returns the details of this API's configuration options.
unsigned int | getDisplayMonitorCount () const override
| Gets the number of display monitors.
String | getErrorDescription (long errorNumber) const override
| Returns a description of an error code.
const String & | getFriendlyName () const override
| Returns the friendly name of the render system.
Real | getHorizontalTexelOffset () override
| Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.
Real | getMaximumDepthInputValue () override
| Gets the maximum (farthest) depth value to be used when rendering using identity transforms.
Real | getMinimumDepthInputValue () override
| Gets the minimum (closest) depth value to be used when rendering using identity transforms.
const String & | getName () const override
| Returns the name of the rendering system.
const PixelFormatToShaderType * | getPixelFormatToShaderType () const override
Real | getVerticalTexelOffset () override
| Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.
bool | hasAnisotropicMipMapFilter () const override
| Determines if the system has anisotropic mip map filter support.
void | initGPUProfiling () override
void | initialiseFromRenderSystemCapabilities (RenderSystemCapabilities *caps, Window *primary) override
| Initialize the render system from the capabilities.
void | markProfileEvent (const String &event) override
| Marks an instantaneous event for graphics profilers.
void | postExtraThreadsStarted () override
void | preExtraThreadsStarted () override
| Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.
void | registerThread () override
| Register the an additional thread which may make calls to rendersystem-related objects.
void | reinitialise () override
| Restart the renderer (normally following a change in settings).
void | setClipPlanesImpl (const PlaneList &clipPlanes) override
| Internal method used to set the underlying clip planes when needed.
void | setConfigOption (const String &name, const String &value) override
| Sets an option for this API.
void | shutdown () override
| Shutdown the renderer and cleanup resources.
void | unregisterThread () override
| Unregister an additional thread which may make calls to rendersystem-related objects.
String | validateConfigOptions () override
| Validates the options set for the rendering system, returning a message if there are problems.
Public Member Functions inherited from Ogre::RenderSystem
| RenderSystem ()
| Default Constructor.
virtual | ~RenderSystem ()
| Destructor.
void | _addMetrics (const RenderingMetrics &newMetrics)
virtual void | _beginFrameOnce ()
| Signifies the beginning of the main frame.
void | _cleanupDepthBuffers ()
virtual void | _clearStateAndFlushCommandBuffer ()
| On D3D11 calls ClearState followed by Flush().
virtual void | _convertOpenVrProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest)
| Converts an OpenVR projection matrix to have the proper depth range and reverse Z settings.
virtual bool | _createRenderWindows (const RenderWindowDescriptionList &renderWindowDescriptions, WindowList &createdWindows)
| Creates multiple rendering windows.
void | _dereferenceSharedDepthBuffer (TextureGpu *depthBuffer)
| Releases the reference count on a shared depth buffer.
virtual void | _descriptorSetSamplerCreated (DescriptorSetSampler *newSet)
virtual void | _descriptorSetSamplerDestroyed (DescriptorSetSampler *set)
virtual void | _descriptorSetTexture2Created (DescriptorSetTexture2 *newSet)
virtual void | _descriptorSetTexture2Destroyed (DescriptorSetTexture2 *set)
virtual void | _descriptorSetTextureCreated (DescriptorSetTexture *newSet)
virtual void | _descriptorSetTextureDestroyed (DescriptorSetTexture *set)
virtual void | _descriptorSetUavCreated (DescriptorSetUav *newSet)
virtual void | _descriptorSetUavDestroyed (DescriptorSetUav *set)
virtual void | _endFrameOnce ()
| Called once per frame, regardless of how many active workspaces there are.
Viewport & | _getCurrentRenderViewport ()
virtual const String & | _getDefaultViewportMaterialScheme () const
| Returns the default material scheme used by the render system.
virtual void | _hlmsBlendblockCreated (HlmsBlendblock *newBlock)
virtual void | _hlmsBlendblockDestroyed (HlmsBlendblock *block)
virtual void | _hlmsComputePipelineStateObjectCreated (HlmsComputePso *newPso)
virtual void | _hlmsComputePipelineStateObjectDestroyed (HlmsComputePso *newPso)
virtual void | _hlmsMacroblockCreated (HlmsMacroblock *newBlock)
virtual void | _hlmsMacroblockDestroyed (HlmsMacroblock *block)
virtual void | _hlmsPipelineStateObjectCreated (HlmsPso *newPso)
virtual void | _hlmsPipelineStateObjectDestroyed (HlmsPso *pso)
virtual void | _hlmsSamplerblockCreated (HlmsSamplerblock *newBlock)
virtual void | _hlmsSamplerblockDestroyed (HlmsSamplerblock *block)
virtual void | _makeRsProjectionMatrix (const Matrix4 &matrix, Matrix4 &dest, Real nearPlane, Real farPlane, ProjectionType projectionType)
| Takes a regular source projection matrix in range [-1; 1] and converts it to a projection matrix in 'dest' with reverse Z range [1; 0].
virtual RenderSystemContext * | _pauseFrame ()
| Pause rendering for a frame.
virtual void | _render (const v1::RenderOperation &op)
| Render something to the active viewport.
virtual void | _renderEmulatedNoBaseInstance (const CbDrawCallIndexed *cmd)
virtual void | _renderEmulatedNoBaseInstance (const CbDrawCallStrip *cmd)
virtual void | _renderNoBaseInstance (const v1::CbDrawCallIndexed *cmd)
virtual void | _renderNoBaseInstance (const v1::CbDrawCallStrip *cmd)
void | _resetMetrics ()
virtual void | _resumeFrame (RenderSystemContext *context)
| Resume rendering for a frame.
virtual void | _setBindingType (TextureUnitState::BindingType bindigType)
| Set texture unit binding type.
virtual void | _setGeometryTexture (size_t unit, TextureGpu *tex)
virtual void | _setTessellationDomainTexture (size_t unit, TextureGpu *tex)
virtual void | _setTessellationHullTexture (size_t unit, TextureGpu *tex)
virtual void | _setTextureProjectionRelativeTo (bool enabled, const Vector3 &pos)
| Notify the rendersystem that it should adjust texture projection to be relative to a different origin.
virtual void | _setTextureUnitSettings (size_t texUnit, TextureUnitState &tl)
| Utility function for setting all the properties of a texture unit at once.
virtual void | _setVertexTexture (size_t unit, TextureGpu *tex)
| Binds a texture to a vertex, geometry, compute, tessellation hull or tessellation domain sampler.
virtual void | _setWorldMatrices (const Matrix4 *m, unsigned short count)
| Sets multiple world matrices (vertex blending).
virtual void | _startLegacyV1Rendering ()
| May override the current VertexArrayObject!
void | _update ()
| Called once per frame, regardless of how many active workspaces there are.
virtual void | addClipPlane (const Plane &p)
| Add a user clipping plane.
virtual void | addClipPlane (Real A, Real B, Real C, Real D)
| Add a user clipping plane.
virtual void | addListener (Listener *l)
| Adds a listener to the custom events that this render system can raise.
virtual bool | areFixedFunctionLightsInViewSpace () const
| Are fixed-function lights provided in view space?
virtual void | beginRenderPassDescriptor (RenderPassDescriptor *desc, TextureGpu *anyTarget, uint8 mipLevel, const Vector4 *viewportSizes, const Vector4 *scissors, uint32 numViewports, bool overlaysEnabled, bool warnIfRtvWasFlushed)
| When the descriptor is set to Load clear, two possible things may happen:
virtual bool | checkExtension (const String &ext) const
| Checks for the presense of an API-specific extension (eg. Vulkan, GL).
virtual void | compositorWorkspaceBegin (CompositorWorkspace *workspace, const bool forceBeginFrame)
| See RenderSystem::updateCompositorManager.
virtual void | compositorWorkspaceEnd (CompositorWorkspace *workspace, const bool forceEndFrame)
| See RenderSystem::updateCompositorManager.
virtual void | compositorWorkspaceUpdate (CompositorWorkspace *workspace)
| See RenderSystem::updateCompositorManager.
virtual void | convertColourValue (const ColourValue &colour, uint32 *pDest)
| Generates a packed data version of the passed in ColourValue suitable for use as with this RenderSystem.
virtual void | debugAnnotationPop ()
virtual void | debugAnnotationPush (const String &event)
| Specifically meant to mark passes in RenderDoc.
virtual void | destroyHardwareOcclusionQuery (HardwareOcclusionQuery *hq)
| Destroy a hardware occlusion query object.
void | destroyRenderPassDescriptor (RenderPassDescriptor *renderPassDesc)
virtual void | destroyRenderWindow (Window *window)
| Destroys a render window.
virtual void | endCopyEncoder ()
| Required when caller will soon start analyzing barriers (e.g.
virtual void | endGpuDebuggerFrameCapture (Window *window, const bool bDiscard=false)
| See RenderSystem::startGpuDebuggerFrameCapture Call this function when you're done capturing a frame.
virtual void | endRenderPassDescriptor ()
virtual void | executeRenderPassDescriptorDelayedActions ()
| Metal needs to delay RenderCommand creation to the last minute, because we can't issue blit operations (e.g.
virtual void | executeResourceTransition (const ResourceTransitionArray &rstCollection)
BarrierSolver & | getBarrierSolver ()
BoundUav | getBoundUav (size_t slot) const
const RenderSystemCapabilities * | getCapabilities () const
| Gets the capabilities of the render system.
RenderPassDescriptor * | getCurrentPassDescriptor ()
Viewport * | getCurrentRenderViewports ()
virtual void | getCustomAttribute (const String &name, void *pData)
| Gets a custom (maybe platform-specific) attribute.
bool | getDebugShaders () const
virtual TextureGpu * | getDepthBufferFor (TextureGpu *colourTexture, uint16 poolId, bool preferDepthTexture, PixelFormatGpu depthBufferFormat)
virtual const DriverVersion & | getDriverVersion () const
| Returns the driver version.
v1::HardwareVertexBufferSharedPtr | getGlobalInstanceVertexBuffer () const
| Returns the global instance vertex buffer.
v1::VertexDeclaration * | getGlobalInstanceVertexBufferVertexDeclaration () const
| Gets vertex declaration for the global vertex buffer for the global instancing.
size_t | getGlobalNumberOfInstances () const
| Gets the global number of instances.
bool | getInvertedClipSpaceY () const
| +Y is downwards in NDC (Normalized Device Coordinates). Only Vulkan has this problem.
virtual bool | getInvertVertexWinding () const
| Indicates whether or not the vertex windings set will be inverted for the current render (e.g.
uint32 | getMaxBoundViewports ()
const RenderingMetrics & | getMetrics () const
RenderSystemCapabilities * | getMutableCapabilities ()
| Get a pointer to the current capabilities being used by the RenderSystem.
uint16 | getNativeShadingLanguageVersion () const
| Gets the native shading language version for this render system.
virtual size_t | getNumPriorityConfigOptions () const
| Number of priority config options in RenderSystem::getPriorityConfigOption.
virtual const char * | getPriorityConfigOption (size_t idx) const
| Some options depend on other options.
RENDERDOC_API_1_4_1 * | getRenderDocApi ()
| Returns the RenderDoc API handle in case you want to do more advanced functionality than what we expose.
virtual const StringVector & | getRenderSystemEvents () const
| Gets a list of the rendersystem specific events that this rendersystem can raise.
virtual Real | getRSDepthRange () const
| OpenGL depth is in range [-1;1] so it returns 2.0f; D3D11 & Metal are in range [0;1] so it returns 1.0f;.
const StencilParams & | getStencilBufferParams () const
TextureGpuManager * | getTextureGpuManager () const
VaoManager * | getVaoManager () const
bool | getWBufferEnabled () const
| Returns true if the renderer will try to use W-buffers when available.
virtual bool | isGpuProgramBound (GpuProgramType gptype)
| Returns whether or not a Gpu program of the given type is currently bound.
bool | isReverseDepth () const
virtual bool | isSameLayout (ResourceLayout::Layout a, ResourceLayout::Layout b, const TextureGpu *texture, bool bIsDebugCheck) const
| Returns true if 'a' and 'b' internally map to the same layout and should be considered equivalent for a given texture.
virtual bool | isStaticBufferLockable () const
bool | loadRenderDocApi ()
| Explicitly loads RenderDoc.
void | queueBindUAVs (const DescriptorSetUav *descSetUav)
| Queues the binding of an UAV to the binding point/slot.
virtual void | removeListener (Listener *l)
| Remove a listener to the custom events that this render system can raise.
virtual void | resetClipPlanes ()
| Clears the user clipping region.
virtual void | setClipPlanes (const PlaneList &clipPlanes)
| Sets the user clipping region.
virtual void | setCurrentPassIterationCount (const size_t count)
| set the current multi pass count value.
void | setDebugShaders (bool bDebugShaders)
| Instructs the RenderSystem to compile shaders without optimizations and with debug information, for easier debugging on APIs that support it.
virtual void | setDeriveDepthBias (bool derive, float baseValue=0.0f, float multiplier=0.0f, float slopeScale=0.0f)
| Tell the render system whether to derive a depth bias on its own based on the values passed to it in setCurrentPassIterationCount.
virtual bool | setDrawBuffer (ColourBufferType colourBuffer)
| Sets the colour buffer that the render system will to draw.
void | setGlobalInstanceVertexBuffer (const v1::HardwareVertexBufferSharedPtr &val)
| Sets the global instance vertex buffer.
void | setGlobalInstanceVertexBufferVertexDeclaration (v1::VertexDeclaration *val)
| Sets vertex declaration for the global vertex buffer for the global instancing.
void | setGlobalNumberOfInstances (const size_t val)
| Sets the global number of instances.
void | setInvertVertexWinding (bool invert)
| Sets whether or not vertex windings set should be inverted; this can be important for rendering reflections.
void | setMetricsRecordingEnabled (bool bEnable)
virtual void | setStencilBufferParams (uint32 refValue, const StencilParams &stencilParams)
| This method allows you to set all the stencil buffer parameters in one call.
void | setUavStartingSlot (uint32 startingSlot)
| In Direct3D11, UAV & RenderTargets share the same slots.
void | setWBufferEnabled (bool enabled)
| Sets whether or not W-buffers are enabled if they are available for this renderer.
virtual bool | startGpuDebuggerFrameCapture (Window *window)
| Programmatically performs a GPU capture when attached to a GPU debugger like RenderDoc or Metal Graphics Debugger.
virtual void | updateCompositorManager (CompositorManager2 *compositorManager)
| This gives the renderer a chance to perform the compositor update in a special way.
virtual void | useCustomRenderSystemCapabilities (RenderSystemCapabilities *capabilities)
| Force the render system to use the special capabilities.
virtual bool | validateDevice (bool forceDeviceElection=false)
| Some render systems have moments when GPU device is temporarily unavailable, for example when D3D11 device is lost, or when iOS app is in background, etc.
virtual SampleDescription | validateSampleDescription (const SampleDescription &sampleDesc, PixelFormatGpu format)
| Returns supported sample description for requested FSAA mode, with graceful downgrading.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::RenderSystem
static void | addSharedListener (Listener *listener)
| Sets shared listener.
static void | fireSharedEvent (const String &name, const NameValuePairList *params=0)
static void | removeSharedListener (Listener *listener)
| Remove shared listener to the custom events that this render system can raise.
static CompareFunction | reverseCompareFunction (CompareFunction depthFunc)
| Reverts the compare order e.g.

## Detailed Description

Implementation of NULL as a rendering system.

## Constructor & Destructor Documentation

## ◆ NULLRenderSystem()

Ogre::NULLRenderSystem::NULLRenderSystem | ( |  | ) |

## ◆ ~NULLRenderSystem()

Ogre::NULLRenderSystem::~NULLRenderSystem | ( |  | ) |
| override

## Member Function Documentation

## ◆ _beginFrame()

void Ogre::NULLRenderSystem::_beginFrame | ( |  | ) |
| overridevirtual

Signifies the beginning of a frame, i.e.

the start of rendering on a single viewport. Will occur several times per complete frame if multiple viewports exist.

Implements Ogre::RenderSystem.

## ◆ _convertProjectionMatrix()

void Ogre::NULLRenderSystem::_convertProjectionMatrix | ( | const Matrix4 & | matrix,
|  | Matrix4 & | dest )
| inlineoverridevirtual

Converts a uniform projection matrix to suitable for this render system.

Remarks
  Because different APIs have different requirements (some incompatible) for the projection matrix, this method allows each to implement their own correctly and pass back a generic OGRE matrix for storage in the engine.

Reimplemented from Ogre::RenderSystem.

## ◆ _createRenderWindow()

Window * Ogre::NULLRenderSystem::_createRenderWindow | ( | const String & | name,
|  | uint32 | width,
|  | uint32 | height,
|  | bool | fullScreen,
|  | const NameValuePairList * | miscParams = 0 )
| overridevirtual

Creates a new rendering window.

Remarks
  This method creates a new rendering window as specified by the paramteters. The rendering system could be responible for only a single window (e.g. in the case of a game), or could be in charge of multiple ones (in the case of a level editor). The option to create the window as a child of another is therefore given. This method will create an appropriate subclass of RenderWindow depending on the API and platform implementation.

  After creation, this window can be retrieved using getRenderTarget().

Parameters

  name | The name of the window. Used in other methods later like setRenderTarget and getRenderTarget.
  width | The width of the new window.
  height | The height of the new window.
  fullScreen | Specify true to make the window full screen without borders, title bar or menu bar.
  miscParams | A NameValuePairList describing the other parameters for the new rendering window. Options are case sensitive. Unrecognised parameters will be ignored silently. These values might be platform dependent, but these are present for all platforms unless indicated otherwise:
  Key | Type/Values | Default | Description | Notes
  title | Any string | RenderTarget name | The title of the window that will appear in the title bar |
  colourDepth | 16, 32 | Desktop depth | Colour depth of the resulting rendering window; only applies if fullScreen | Win32 Specific
  left | Positive integers | Centred | Screen x coordinate from left |
  top | Positive integers | Centred | Screen y coordinate from left |
  depthBuffer | true, false | true | Use depth buffer | DirectX9 specific
  externalWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) OS X Cocoa: OgreGLView address as an integer. You can pass NSView or NSWindow too, but should perform OgreGLView callbacks into the Ogre manually. iOS: UIWindow address as an integer | 0 (none) | External window handle, for embedding the OGRE render in an existing window |
  externalGLControl | true, false | false | Let the external window control OpenGL i.e. don't select a pixel format for the window, do not change v-sync and do not swap buffer. When set to true, the calling application is responsible of OpenGL initialization and buffer swapping. It should also create an OpenGL context for its own rendering, Ogre will create one for its use. Then the calling application must also enable Ogre OpenGL context before calling any Ogre function and restore its OpenGL context after these calls. | OpenGL specific
  externalGLContext | Context as Unsigned Long | 0 (create own context) | Use an externally created GL context | OpenGL Specific
  parentWindowHandle | Win32: HWND as integer GLX: poslong:posint:poslong (display*:screen:windowHandle) or poslong:posint:poslong:poslong (display*:screen:windowHandle:XVisualInfo*) | 0 (none) | Parent window handle, for embedding the OGRE in a child of an external window |
  contentScalingFactor | Positive Float greater than 1.0 | The default content scaling factor of the screen | Specifies the CAEAGLLayer content scaling factor. Only supported on iOS 4 or greater. This can be useful to limit the resolution of the OpenGL ES backing store. For example, the iPhone 4's native resolution is 960 x 640. Windows are always 320 x 480, if you would like to limit the display to 720 x 480, specify 1.5 as the scaling factor. | iOS Specific |
  externalViewHandle | UIView pointer as an integer | 0 | External view handle, for rendering OGRE render in an existing view | iOS Specific |
  externalViewControllerHandle | UIViewController pointer as an integer | 0 | External view controller handle, for embedding OGRE in an existing view controller | iOS Specific |
  externalSharegroup | EAGLSharegroup pointer as an integer | 0 | External sharegroup, used to shared GL resources between contexts | iOS Specific |
  Full Screen | true, false | false | Specify whether to create the window in full screen mode | OS X Specific |
  MSAA | Positive integer (usually 1, 2, 4, 8, 16) | 1 | Multisample antialiasing factor |
  MSAA_Quality | Depends on RenderSystem and hardware. Currently supports: 0 ... infinite number (depends on HW) | Blank | Full screen antialiasing hint |
  displayFrequency | Refresh rate in Hertz (e.g. 60, 75, 100) | Desktop vsync rate | Display frequency rate, for fullscreen mode |
  vsync | true, false | false | Synchronize buffer swaps to monitor vsync, eliminating tearing at the expense of a fixed frame rate |
  vsyncInterval | 1, 2, 3, 4 | 1 | If vsync is enabled, the minimum number of vertical blanks that should occur between renders. For example if vsync is enabled, the refresh rate is 60 and this is set to 2, then the frame rate will be locked at 30. |
  border | none, fixed, resize | resize | The type of window border (in windowed mode) |
  outerDimensions | true, false | false | Whether the width/height is expressed as the size of the outer window, rather than the content area |
  useNVPerfHUD | true, false | false | Enable the use of nVidia NVPerfHUD |
  gamma | true, false | false | Enable hardware conversion from linear colour space to gamma colour space on rendering to the window. |
  enableDoubleClick | true, false | false | Enable the window to keep track and transmit double click messages. | Win32 Specific
  MSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Full screen antialiasing factor | Android Specific
  CSAA | Positive integer (usually 0, 2, 4, 8, 16) | 0 | Coverage sampling factor (https://www.khronos.org/registry/egl/extensions/NV/EGL_NV_coverage_sample.txt) | Android Specific
  maxColourBufferSize | Positive integer (usually 16, 32) | 32 | Max EGL_BUFFER_SIZE | Android Specific
  minColourBufferSize | Positive integer (usually 16, 32) | 16 | Min EGL_BUFFER_SIZE | Android Specific
  maxStencilBufferSize | Positive integer (usually 0, 8) | 0 | EGL_STENCIL_SIZE | Android Specific
  maxDepthBufferSize | Positive integer (usually 0, 16, 24) | 16 | EGL_DEPTH_SIZE | Android Specific

Implements Ogre::RenderSystem.

## ◆ _dispatch()

void Ogre::NULLRenderSystem::_dispatch | ( | const HlmsComputePso & | pso | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _endFrame()

void Ogre::NULLRenderSystem::_endFrame | ( |  | ) |
| overridevirtual

Ends rendering of a frame to the current viewport.

Implements Ogre::RenderSystem.

## ◆ _initialise()

Window * Ogre::NULLRenderSystem::_initialise | ( | bool | autoCreateWindow,
|  | const String & | windowTitle = "OGRE Render Window" )
| overridevirtual

Start up the renderer using the settings selected (Or the defaults if none have been selected).

Remarks
  Called by Root::setRenderSystem. Shouldn't really be called directly, although this can be done if the app wants to.

Parameters

  autoCreateWindow | If true, creates a render window automatically, based on settings chosen so far. This saves an extra call to _createRenderWindow for the main render window.
  windowTitle | Sets the app window title

Returns
  A pointer to the automatically created window, if requested, otherwise null.

Reimplemented from Ogre::RenderSystem.

## ◆ _render() [1/4]

void Ogre::NULLRenderSystem::_render | ( | const CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Renders the VAO. Assumes _setVertexArrayObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [2/4]

void Ogre::NULLRenderSystem::_render | ( | const CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _render() [3/4]

void Ogre::NULLRenderSystem::_render | ( | const v1::CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Renders a V1 RenderOperation. Assumes _setRenderOperation has already been called.

Implements Ogre::RenderSystem.

## ◆ _render() [4/4]

void Ogre::NULLRenderSystem::_render | ( | const v1::CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulated() [1/2]

void Ogre::NULLRenderSystem::_renderEmulated | ( | const CbDrawCallIndexed * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _renderEmulated() [2/2]

void Ogre::NULLRenderSystem::_renderEmulated | ( | const CbDrawCallStrip * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setComputePso()

void Ogre::NULLRenderSystem::_setComputePso | ( | const HlmsComputePso * | pso | ) |
| overridevirtual

Unlike _setPipelineStateObject, the RenderSystem will check if the PSO has changed to avoid redundant state changes (since it's hard to do it at Hlms level).

Implements Ogre::RenderSystem.

## ◆ _setCurrentDeviceFromTexture()

void Ogre::NULLRenderSystem::_setCurrentDeviceFromTexture | ( | TextureGpu * | texture | ) |
| overridevirtual

Because Ogre doesn't (yet) have the notion of a 'device' or 'GL context', this function lets Ogre know which device should be used by providing a texture.

Parameters

  texture | Cannot be null.

Implements Ogre::RenderSystem.

## ◆ _setHlmsSamplerblock()

void Ogre::NULLRenderSystem::_setHlmsSamplerblock | ( | uint8 | texUnit,
|  | const HlmsSamplerblock * | Samplerblock )
| overridevirtual

See HlmsSamplerblock.

This function MUST be called after _setTexture, not before. Otherwise not all APIs may see the change.

Implements Ogre::RenderSystem.

## ◆ _setIndirectBuffer()

void Ogre::NULLRenderSystem::_setIndirectBuffer | ( | IndirectBufferPacked * | indirectBuffer | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setPipelineStateObject()

void Ogre::NULLRenderSystem::_setPipelineStateObject | ( | const HlmsPso * | pso | ) |
| overridevirtual

See also
  HlmsPso

Reimplemented from Ogre::RenderSystem.

## ◆ _setPointParameters()

void Ogre::NULLRenderSystem::_setPointParameters | ( | Real | size,
|  | bool | attenuationEnabled,
|  | Real | constant,
|  | Real | linear,
|  | Real | quadratic,
|  | Real | minSize,
|  | Real | maxSize )
| overridevirtual

Sets the size of points and how they are attenuated with distance.

Remarks
  When performing point rendering or point sprite rendering, point size can be attenuated with distance. The equation for doing this is attenuation = 1 / (constant + linear * dist + quadratic * d^2) .

  For example, to disable distance attenuation (constant screensize) you would set constant to 1, and linear and quadratic to 0. A standard perspective attenuation would be 0, 1, 0 respectively.

Implements Ogre::RenderSystem.

## ◆ _setPointSpritesEnabled()

void Ogre::NULLRenderSystem::_setPointSpritesEnabled | ( | bool | enabled | ) |
| overridevirtual

Sets whether or not rendering points using OT_POINT_LIST will render point sprites (textured quads) or plain points.

Parameters

  enabled | True enables point sprites, false returns to normal point rendering.

Implements Ogre::RenderSystem.

## ◆ _setProjectionMatrix()

void Ogre::NULLRenderSystem::_setProjectionMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

Sets the projection transform matrix.

Implements Ogre::RenderSystem.

## ◆ _setRenderOperation()

void Ogre::NULLRenderSystem::_setRenderOperation | ( | const v1::CbRenderOp * | cmd | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSamplers()

void Ogre::NULLRenderSystem::_setSamplers | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSamplersCS()

void Ogre::NULLRenderSystem::_setSamplersCS | ( | uint32 | slotStart,
|  | const DescriptorSetSampler * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setSurfaceParams()

void Ogre::NULLRenderSystem::_setSurfaceParams | ( | const ColourValue & | ambient,
|  | const ColourValue & | diffuse,
|  | const ColourValue & | specular,
|  | const ColourValue & | emissive,
|  | Real | shininess,
|  | TrackVertexColourType | tracking = TVC_NONE )
| overridevirtual

Sets the surface properties to be used for future rendering.

This method sets the the properties of the surfaces of objects to be rendered after it. In this context these surface properties are the amount of each type of light the object reflects (determining it's colour under different types of light), whether it emits light itself, and how shiny it is. Textures are not dealt with here, see the _setTetxure method for details. This method is used by _setMaterial so does not need to be called direct if that method is being used.

Parameters

  ambient | The amount of ambient (sourceless and directionless) light an object reflects. Affected by the colour/amount of ambient light in the scene.
  diffuse | The amount of light from directed sources that is reflected (affected by colour/amount of point, directed and spot light sources)
  specular | The amount of specular light reflected. This is also affected by directed light sources but represents the colour at the highlights of the object.
  emissive | The colour of light emitted from the object. Note that this will make an object seem brighter and not dependent on lights in the scene, but it will not act as a light, so will not illuminate other objects. Use a light attached to the same SceneNode as the object for this purpose.
  shininess | A value which only has an effect on specular highlights (so specular must be non-black). The higher this value, the smaller and crisper the specular highlights will be, imitating a more highly polished surface. This value is not constrained to 0.0-1.0, in fact it is likely to be more (10.0 gives a modest sheen to an object).
  tracking | A bit field that describes which of the ambient, diffuse, specular and emissive colours follow the vertex colour of the primitive. When a bit in this field is set its ColourValue is ignored. This is a combination of TVC_AMBIENT, TVC_DIFFUSE, TVC_SPECULAR(note that the shininess value is still taken from shininess) and TVC_EMISSIVE. TVC_NONE means that there will be no material property tracking the vertex colours.

Implements Ogre::RenderSystem.

References Ogre::TVC_NONE.

## ◆ _setTexture()

void Ogre::NULLRenderSystem::_setTexture | ( | size_t | unit,
|  | TextureGpu * | texPtr,
|  | bool | bDepthReadOnly )
| overridevirtual

Sets the texture to bind to a given texture unit.

User processes would not normally call this direct unless rendering primitives themselves.

Parameters

  unit | The index of the texture unit to modify. Multitexturing hardware can support multiple units (see RenderSystemCapabilites::getNumTextureUnits)
  enabled | Boolean to turn the unit on/off
  texPtr | Pointer to the texture to use.
  bDepthReadOnly | true if the texture is also attached as a depth buffer but is read only

Implements Ogre::RenderSystem.

## ◆ _setTextureBlendMode()

void Ogre::NULLRenderSystem::_setTextureBlendMode | ( | size_t | unit,
|  | const LayerBlendModeEx & | bm )
| overridevirtual

Sets the texture blend modes from a TextureUnitState record.

Meant for use internally only - apps should use the Material and TextureUnitState classes.

Parameters

  unit | Texture unit as above
  bm | Details of the blending mode

Implements Ogre::RenderSystem.

## ◆ _setTextureCoordCalculation()

void Ogre::NULLRenderSystem::_setTextureCoordCalculation | ( | size_t | unit,
|  | TexCoordCalcMethod | m,
|  | const Frustum * | frustum = 0 )
| overridevirtual

Sets a method for automatically calculating texture coordinates for a stage.

Should not be used by apps - for use by Ogre only.

Parameters

  unit | Texture unit as above
  m | Calculation method to use
  frustum | Optional Frustum param, only used for projective effects

Implements Ogre::RenderSystem.

## ◆ _setTextureMatrix()

void Ogre::NULLRenderSystem::_setTextureMatrix | ( | size_t | unit,
|  | const Matrix4 & | xform )
| overridevirtual

Sets the texture coordinate transformation matrix for a texture unit.

Parameters

  unit | Texture unit to affect
  xform | The 4x4 matrix

Implements Ogre::RenderSystem.

## ◆ _setTextures() [1/2]

void Ogre::NULLRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set,
|  | uint32 | hazardousTexIdx )
| overridevirtual

Parameters

  slotStart |
  set |
  hazardousTexIdx | When hazardousTexIdx < set->mTextures.size(); it means that we need to check if set->mTextures[hazardousTexIdx] is not the same as the currently bound RTT.

Implements Ogre::RenderSystem.

## ◆ _setTextures() [2/2]

void Ogre::NULLRenderSystem::_setTextures | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [1/2]

void Ogre::NULLRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setTexturesCS() [2/2]

void Ogre::NULLRenderSystem::_setTexturesCS | ( | uint32 | slotStart,
|  | const DescriptorSetTexture2 * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setUavCS()

void Ogre::NULLRenderSystem::_setUavCS | ( | uint32 | slotStart,
|  | const DescriptorSetUav * | set )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ _setVertexArrayObject()

void Ogre::NULLRenderSystem::_setVertexArrayObject | ( | const VertexArrayObject * | vao | ) |
| overridevirtual

Part of the low level rendering interface.

Tells the RS which VAO will be bound now. (i.e. Vertex Formats, buffers being bound, etc.) You don't need to rebind if the VAO's mRenderQueueId is the same as previous call.

Remarks
  Assumes _setPipelineStateObject has already been called.

Implements Ogre::RenderSystem.

## ◆ _setViewMatrix()

void Ogre::NULLRenderSystem::_setViewMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

Sets the view transform matrix.

Implements Ogre::RenderSystem.

## ◆ _setWorldMatrix()

void Ogre::NULLRenderSystem::_setWorldMatrix | ( | const Matrix4 & | m | ) |
| overridevirtual

Sets the world transform matrix.

Implements Ogre::RenderSystem.

## ◆ _useLights()

void Ogre::NULLRenderSystem::_useLights | ( | const LightList & | lights,
|  | unsigned short | limit )
| overridevirtual

Tells the rendersystem to use the attached set of lights (and no others) up to the number specified (this allows the same list to be used with different count limits).

Implements Ogre::RenderSystem.

## ◆ beginGPUSampleProfile()

void Ogre::NULLRenderSystem::beginGPUSampleProfile | ( | const String & | name,
|  | uint32 * | hashCache )
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ beginProfileEvent()

void Ogre::NULLRenderSystem::beginProfileEvent | ( | const String & | eventName | ) |
| overridevirtual

This marks the beginning of an event for GPU profiling.

Implements Ogre::RenderSystem.

## ◆ bindGpuProgramParameters()

void Ogre::NULLRenderSystem::bindGpuProgramParameters | ( | GpuProgramType | gptype,
|  | GpuProgramParametersSharedPtr | params,
|  | uint16 | variabilityMask )
| overridevirtual

Bind Gpu program parameters.

Parameters

  gptype | The type of program to bind the parameters to
  params | The parameters to bind
  variabilityMask | A mask of GpuParamVariability identifying which params need binding

Implements Ogre::RenderSystem.

## ◆ bindGpuProgramPassIterationParameters()

void Ogre::NULLRenderSystem::bindGpuProgramPassIterationParameters | ( | GpuProgramType | gptype | ) |
| overridevirtual

Only binds Gpu program parameters used for passes that have more than one iteration rendering.

Implements Ogre::RenderSystem.

## ◆ clearFrameBuffer()

void Ogre::NULLRenderSystem::clearFrameBuffer | ( | RenderPassDescriptor * | renderPassDesc,
|  | TextureGpu * | anyTarget,
|  | uint8 | mipLevel )
| overridevirtual

Immediately clears the whole frame buffer on the selected RenderPassDescriptor.

Prefer clearing using the LoadAction semantics in the RenderPassDescriptor. This function is provided for two reasons:

1. Backwards compatibility (i.e. easier porting from 2.1)
2. Non-tilers desktop GPUs may be faster to clear the whole framebuffer at once.
   Remarks
     Will break an existing RenderPassDescriptor set via beginRenderPassDescriptor.
   Parameters

     renderPassDesc | RenderPassDescriptor filled with LoadActions set to clear and StoreActions set to Store.

Implements Ogre::RenderSystem.

## ◆ createHardwareOcclusionQuery()

HardwareOcclusionQuery * Ogre::NULLRenderSystem::createHardwareOcclusionQuery | ( |  | ) |
| overridevirtual

Create an object for performing hardware occlusion queries.

Implements Ogre::RenderSystem.

## ◆ createRenderPassDescriptor()

RenderPassDescriptor * Ogre::NULLRenderSystem::createRenderPassDescriptor | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ createRenderSystemCapabilities()

RenderSystemCapabilities * Ogre::NULLRenderSystem::createRenderSystemCapabilities | ( |  | ) | const
| overridevirtual

Query the real capabilities of the GPU and driver in the RenderSystem.

Implements Ogre::RenderSystem.

## ◆ deinitGPUProfiling()

void Ogre::NULLRenderSystem::deinitGPUProfiling | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ endGPUSampleProfile()

void Ogre::NULLRenderSystem::endGPUSampleProfile | ( | const String & | name | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ endProfileEvent()

void Ogre::NULLRenderSystem::endProfileEvent | ( |  | ) |
| overridevirtual

Ends the currently active GPU profiling event.

Implements Ogre::RenderSystem.

## ◆ flushCommands()

void Ogre::NULLRenderSystem::flushCommands | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ getColourVertexElementType()

VertexElementType Ogre::NULLRenderSystem::getColourVertexElementType | ( |  | ) | const
| overridevirtual

Get the native VertexElementType for a compact 32-bit colour value for this rendersystem.

Implements Ogre::RenderSystem.

## ◆ getConfigOptions()

ConfigOptionMap & Ogre::NULLRenderSystem::getConfigOptions | ( |  | ) |
| inlineoverridevirtual

Returns the details of this API's configuration options.

Remarks
  Each render system must be able to inform the world of what options must/can be specified for it's operation.

  These are passed as strings for portability, but grouped into a structure (_ConfigOption) which includes both options and current value.

  Note that the settings returned from this call are affected by the options that have been set so far, since some options are interdependent.

  This routine is called automatically by the default configuration dialogue produced by Root::showConfigDialog or may be used by the caller for custom settings dialogs

Returns
  A 'map' of options, i.e. a list of options which is also indexed by option name.

Implements Ogre::RenderSystem.

## ◆ getDisplayMonitorCount()

unsigned int Ogre::NULLRenderSystem::getDisplayMonitorCount | ( |  | ) | const
| inlineoverridevirtual

Gets the number of display monitors.

See also
  Root::getDisplayMonitorCount

Implements Ogre::RenderSystem.

## ◆ getErrorDescription()

String Ogre::NULLRenderSystem::getErrorDescription | ( | long | errorNumber | ) | const
| overridevirtual

Returns a description of an error code.

Implements Ogre::RenderSystem.

## ◆ getFriendlyName()

const String & Ogre::NULLRenderSystem::getFriendlyName | ( |  | ) | const
| overridevirtual

Returns the friendly name of the render system.

Implements Ogre::RenderSystem.

## ◆ getHorizontalTexelOffset()

Real Ogre::NULLRenderSystem::getHorizontalTexelOffset | ( |  | ) |
| overridevirtual

Returns the horizontal texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the horizontal direction.

Implements Ogre::RenderSystem.

## ◆ getMaximumDepthInputValue()

Real Ogre::NULLRenderSystem::getMaximumDepthInputValue | ( |  | ) |
| overridevirtual

Gets the maximum (farthest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getMinimumDepthInputValue()

Real Ogre::NULLRenderSystem::getMinimumDepthInputValue | ( |  | ) |
| overridevirtual

Gets the minimum (closest) depth value to be used when rendering using identity transforms.

Remarks
  When using identity transforms you can manually set the depth of a vertex; however the input values required differ per rendersystem. This method lets you retrieve the correct value.

See also
  Renderable::getUseIdentityView, Renderable::getUseIdentityProjection

Implements Ogre::RenderSystem.

## ◆ getName()

const String & Ogre::NULLRenderSystem::getName | ( |  | ) | const
| overridevirtual

Returns the name of the rendering system.

Implements Ogre::RenderSystem.

## ◆ getPixelFormatToShaderType()

const PixelFormatToShaderType * Ogre::NULLRenderSystem::getPixelFormatToShaderType | ( |  | ) | const
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ getVerticalTexelOffset()

Real Ogre::NULLRenderSystem::getVerticalTexelOffset | ( |  | ) |
| overridevirtual

Returns the vertical texel offset value required for mapping texel origins to pixel origins in this rendersystem.

Remarks
  Since rendersystems sometimes disagree on the origin of a texel, mapping from texels to pixels can sometimes be problematic to implement generically. This method allows you to retrieve the offset required to map the origin of a texel to the origin of a pixel in the vertical direction.

Implements Ogre::RenderSystem.

## ◆ hasAnisotropicMipMapFilter()

bool Ogre::NULLRenderSystem::hasAnisotropicMipMapFilter | ( |  | ) | const
| inlineoverridevirtual

Determines if the system has anisotropic mip map filter support.

Implements Ogre::RenderSystem.

## ◆ initGPUProfiling()

void Ogre::NULLRenderSystem::initGPUProfiling | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ initialiseFromRenderSystemCapabilities()

void Ogre::NULLRenderSystem::initialiseFromRenderSystemCapabilities | ( | RenderSystemCapabilities * | caps,
|  | Window * | primary )
| overridevirtual

Initialize the render system from the capabilities.

Implements Ogre::RenderSystem.

## ◆ markProfileEvent()

void Ogre::NULLRenderSystem::markProfileEvent | ( | const String & | event | ) |
| overridevirtual

Marks an instantaneous event for graphics profilers.

This is equivalent to calling beginProfileEvent() and endProfileEvent() back to back.

Implements Ogre::RenderSystem.

## ◆ postExtraThreadsStarted()

void Ogre::NULLRenderSystem::postExtraThreadsStarted | ( |  | ) |
| overridevirtual

Implements Ogre::RenderSystem.

## ◆ preExtraThreadsStarted()

void Ogre::NULLRenderSystem::preExtraThreadsStarted | ( |  | ) |
| overridevirtual

Tell the rendersystem to perform any prep tasks it needs to directly before other threads which might access the rendering API are registered.

Remarks
  Call this from your main thread before starting your other threads (which themselves should call registerThread()). Note that if you start your own threads, there is a specific startup sequence which must be respected and requires synchronisation between the threads:
  1. [Main thread]Call preExtraThreadsStarted
  2. [Main thread]Start other thread, wait
  3. [Other thread]Call registerThread, notify main thread & continue
  4. [Main thread]Wake up & call postExtraThreadsStarted
  Once this init sequence is completed the threads are independent but this startup sequence must be respected.

Implements Ogre::RenderSystem.

## ◆ registerThread()

void Ogre::NULLRenderSystem::registerThread | ( |  | ) |
| overridevirtual

Register the an additional thread which may make calls to rendersystem-related objects.

Remarks
  This method should only be called by additional threads during their initialisation. If they intend to use hardware rendering system resources they should call this method before doing anything related to the render system. Some rendering APIs require a per-thread setup and this method will sort that out. It is also necessary to call unregisterThread before the thread shuts down.

Note
  This method takes no parameters - it must be called from the thread being registered and that context is enough.

Implements Ogre::RenderSystem.

## ◆ reinitialise()

void Ogre::NULLRenderSystem::reinitialise | ( |  | ) |
| overridevirtual

Restart the renderer (normally following a change in settings).

Implements Ogre::RenderSystem.

## ◆ setClipPlanesImpl()

void Ogre::NULLRenderSystem::setClipPlanesImpl | ( | const PlaneList & | clipPlanes | ) |
| overridevirtual

Internal method used to set the underlying clip planes when needed.

Implements Ogre::RenderSystem.

## ◆ setConfigOption()

void Ogre::NULLRenderSystem::setConfigOption | ( | const String & | name,
|  | const String & | value )
| inlineoverridevirtual

Sets an option for this API.

Remarks
  Used to confirm the settings (normally chosen by the user) in order to make the renderer able to initialise with the settings as required. This may be video mode, D3D driver, full screen / windowed etc. Called automatically by the default configuration dialog, and by the restoration of saved settings. These settings are stored and only activated when RenderSystem::initialise or RenderSystem::reinitialise are called.

  If using a custom configuration dialog, it is advised that the caller calls RenderSystem::getConfigOptions again, since some options can alter resulting from a selection.

Parameters

  name | The name of the option to alter.
  value | The value to set the option to.

Implements Ogre::RenderSystem.

## ◆ shutdown()

void Ogre::NULLRenderSystem::shutdown | ( |  | ) |
| overridevirtual

Shutdown the renderer and cleanup resources.

Reimplemented from Ogre::RenderSystem.

## ◆ unregisterThread()

void Ogre::NULLRenderSystem::unregisterThread | ( |  | ) |
| overridevirtual

Unregister an additional thread which may make calls to rendersystem-related objects.

See also
  RenderSystem::registerThread

Implements Ogre::RenderSystem.

## ◆ validateConfigOptions()

String Ogre::NULLRenderSystem::validateConfigOptions | ( |  | ) |
| inlineoverridevirtual

Validates the options set for the rendering system, returning a message if there are problems.

Note
  If the returned string is empty, there are no problems.

Implements Ogre::RenderSystem.

References Ogre::BLANKSTRING.

The documentation for this class was generated from the following file:

- OgreNULLRenderSystem.h